LOOT_ROLL_MSG_MATCH_TABLE =
{
    { msg = LOOT_ROLL_ALL_PASSED            , handler = "LOOT_ROLL_ALL_PASSED"  , args = { "item" }                     , values = {} },
    { msg = LOOT_ROLL_DISENCHANT            , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "disenchant" } },
    { msg = LOOT_ROLL_DISENCHANT_SELF       , handler = "LOOT_ROLL_CHOSE"       , args = { "item" }                     , values = { player = "$self$", choice = "disenchant" } },
    { msg = LOOT_ROLL_GREED                 , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "greed" } },
    { msg = LOOT_ROLL_GREED_SELF            , handler = "LOOT_ROLL_CHOSE"       , args = { "item" }                     , values = { player = "$self$", choice = "greed" } },
    { msg = LOOT_ROLL_NEED                  , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "need" } },
    { msg = LOOT_ROLL_NEED_SELF             , handler = "LOOT_ROLL_CHOSE"       , args = { "item" }                     , values = { player = "$self$", choice = "need" } },
    { msg = LOOT_ROLL_PASSED                , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "pass" } },
    { msg = LOOT_ROLL_PASSED_AUTO           , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "pass" } },
    { msg = LOOT_ROLL_PASSED_AUTO_FEMALE    , handler = "LOOT_ROLL_CHOSE"       , args = { "player", "item" }           , values = { choice = "pass" } },
    { msg = LOOT_ROLL_PASSED_SELF           , handler = "LOOT_ROLL_CHOSE"       , args = { "item" }                     , values = { player = "$self$", choice = "pass" } },
    { msg = LOOT_ROLL_PASSED_SELF_AUTO      , handler = "LOOT_ROLL_CHOSE"       , args = { "item" }                     , values = { player = "$self$", choice = "pass" } },
    { msg = LOOT_ROLL_ROLLED_DE             , handler = "LOOT_ROLL_ROLLED"      , args = { "roll", "item", "player" }   , values = { choice = "disenchant" } },
    { msg = LOOT_ROLL_ROLLED_GREED          , handler = "LOOT_ROLL_ROLLED"      , args = { "roll", "item", "player" }   , values = { choice = "greed" } },
    { msg = LOOT_ROLL_ROLLED_NEED           , handler = "LOOT_ROLL_ROLLED"      , args = { "roll", "item", "player" }   , values = { choice = "need" } },
    { msg = LOOT_ROLL_WON                   , handler = "LOOT_ROLL_WON"         , args = { "player", "item" }           , values = {} },
    { msg = LOOT_ROLL_WON_NO_SPAM_DE        , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "player", "roll", "item" }   , values = { choice = "disenchant" } },
    { msg = LOOT_ROLL_WON_NO_SPAM_GREED     , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "player", "roll", "item" }   , values = { choice = "greed" } },
    { msg = LOOT_ROLL_WON_NO_SPAM_NEED      , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "player", "roll", "item" }   , values = { choice = "need" } },
    { msg = LOOT_ROLL_YOU_WON               , handler = "LOOT_ROLL_WON"         , args = { "item" }                     , values = { player = "$self$" } },
    { msg = LOOT_ROLL_YOU_WON_NO_SPAM_DE    , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "roll", "item" }             , values = { player = "$self$", choice = "disenchant" } },
    { msg = LOOT_ROLL_YOU_WON_NO_SPAM_GREED , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "roll", "item" }             , values = { player = "$self$", choice = "greed" } },
    { msg = LOOT_ROLL_YOU_WON_NO_SPAM_NEED  , handler = "LOOT_ROLL_WON_NO_SPAM" , args = { "roll", "item" }             , values = { player = "$self$", choice = "need" } },
}

local function __BuildMsgMatchTable(tab)
    local n, match
    for n, match in pairs(tab) do
        match.__re = "^" .. (match.msg:gsub("([%%%?%*%-%+%.%^%$%(%)%[%]%|])", "%%%1")) .. "$"
        match.__args, match.__cnt = {}, 0
        local arg_num, arg_match = 1
        for arg_match in match.__re:gmatch("%%%%[%%%d%$]-[sd]") do
            arg_num = 0 + (arg_match:match("(%d+)%%%$") or arg_num)
            table.insert(match.__args, match.args[arg_num])
            arg_num = arg_num + 1
        end
        match.__re = match.__re:gsub("%%%%[%%%d%$]-[sd]", "(.+)")
        local n2, match2
        for n2, match2 in pairs(tab) do
            if match2.msg:match(match.__re) then
                match.__cnt = match.__cnt + 1
            end
        end
    end
    table.sort(tab, function(a, b) return a.__cnt < b.__cnt end)
end

function ParseMsgMatchTable(tab, msg)
    if not tab[1].__re then
        __BuildMsgMatchTable(tab)
    end
    local n, match
    for n, match in pairs(tab) do
        local p = { msg:match(match.__re) }
        if p[1] then
            local args, pos, arg, value = {}
            for pos, arg in pairs(match.__args) do
                args[arg] = p[pos]
            end
            for arg, value in pairs(match.values) do
                if value == "$self$" then
                    value = UnitName("player")
                end
                args[arg] = value
            end
            return match.handler, args
        end
    end
end

function CloneTable(tab)
    local ret = {}
    local n, v
    for n, v in pairs(tab) do
        if type(v) == "table" then
            ret[n] = CloneTable(v)
        else
            ret[n] = v
        end
    end
    local t_meta = getmetatable(tab)
    if t_meta then
        local r_meta = {}
        for n, v in pairs(t_meta) do
            r_meta[n] = v
        end
        setmetatable(ret, r_meta)
    end
    return ret
end

function GetSubtable(tab, ...)
    local p = { ... }
    local n, ret
    for n in pairs(p) do
        ret = tab[p[n]]
        if not ret then
            ret = {}
            tab[p[n]] = ret
        end
        tab = ret
    end
    return ret
end

function NT_IsInInstance()
    local name, type = GetInstanceInfo()
    if type == "none" then
        return nil
    end
    return name
end

function NT_IsInRaid()
    return GetNumRaidMembers() > 0
end

function NT_IsInParty()
    return GetNumPartyMembers() > 0
end

function NT_IsInLFGParty()
    return false
end

local function __TrimColors(text)
    return text
        :gsub("%|c%x%x%x%x%x%x%x%x", "")
        :gsub("%|r", "")
end

function TrimColors(text)
    local ret = ""
    while text ~= "" do
        local p1, p2, p3 = text:match("^(.-)(%|c%x%x%x%x%x%x%x%x%|Hitem:.-%|h%|r)(.*)$")
        if not p1 then
            ret = ret .. __TrimColors(text)
            break
        end
        ret = ret .. __TrimColors(p1) .. p2
        text = p3
    end
    return ret
end

function ChatIsAvailable(channel)
    if channel == "RAID" then
        return NT_IsInRaid()
    elseif channel == "PARTY" then
        return NT_IsInParty()
    elseif channel == "GUILD" then
        return NT_IsInGuild()
    else
        return true
    end
end

function PrintToChat(msg, channel)
    if channel then
        if ChatIsAvailable(channel) then
            SendChatMessage(TrimColors(msg), channel)
        end
    else
        print(msg)
    end
end
