local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTracker", true)

NTGuiResetClass = {}

function NTGuiResetClass:Create(...)
    local ret = CloneTable(NTGuiResetClass)
    if ret.Initialize then
        ret:Initialize(...)
    end
    return ret
end

function NTGuiResetClass:Initialize(parent, watch)
    self.parent = parent
    self.watch = watch

    LibStub("AceEvent-3.0"):Embed(self)

    self:RegisterMessage("NT_ENTER_INSTANCE", "EventEnterInstance")
    self:RegisterMessage("NT_JOIN_RAID", "EventJoinRaid")
    self:RegisterMessage("NT_JOIN_PARTY", "EventJoinParty")

    local frame = CreateFrame("Frame", nil, UIParent)
    frame:SetBackdrop({
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = true, tileSize = 16, edgeSize = 16,
        insets = { left = 4, right = 4, top = 4, bottom = 4 },
    })
    frame:SetBackdropColor(0.1, 0.1, 0.1)
    frame:SetBackdropBorderColor(1.0, 1.0, 1.0)

    frame.title = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    frame.title:SetText("Needja Tracker")
    frame.title:SetTextColor(1.0, 1.0, 0.0)

    frame.label = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    frame.label:SetText(L.clear_stat)
    frame.label:SetTextColor(1.0, 1.0, 1.0)

    frame.btn_yes = CreateFrame("Button", nil, frame, "OptionsButtonTemplate")
    frame.btn_yes:SetText(L.btn_yes)
    frame.btn_yes:SetWidth(60)

    frame.btn_no= CreateFrame("Button", nil, frame, "OptionsButtonTemplate")
    frame.btn_no:SetText(L.btn_no)
    frame.btn_no:SetWidth(60)

    frame:ClearAllPoints()

    frame.title:SetPoint("TOP", UIParent, "CENTER", 0, 150)
    frame.label:SetPoint("TOP", frame.title, "BOTTOM", 0, -10)
    frame.btn_yes:SetPoint("TOPRIGHT", frame.label, "BOTTOM", 0, -10)
    frame.btn_no:SetPoint("TOPLEFT", frame.btn_yes, "TOPRIGHT", 0, 0)

    frame:SetPoint("TOP", frame.title, "TOP", 0, 10)
    frame:SetPoint("BOTTOM", frame.btn_yes, "BOTTOM", 0, -10)
    frame:SetPoint("LEFT", frame.label, "LEFT", -10, 0)
    frame:SetPoint("RIGHT", frame.label, "RIGHT", 10, 0)

    frame.btn_yes:SetScript("OnClick",
        function()
            self.watch:ClearStatistics()
            self.frame:Hide()
        end)

    frame.btn_no:SetScript("OnClick",
        function()
            self.frame:Hide()
        end)

    self.frame = frame
    frame:Hide()
end

function NTGuiResetClass:EventEnterInstance()
    self.frame:Show()
end

function NTGuiResetClass:EventJoinRaid()
    self.frame:Show()
end

function NTGuiResetClass:EventJoinParty()
    self.frame:Show()
end
